#ifndef _NECI_H
#define _NECI_H


#if !(defined(_WINSOCKAPI_) || defined(_WINSOCKAPI2_))
#include <winsock2.h>
#endif


/* define HWID */
#define MIINEPORTE2		0x71A1
#define MIINEPORTE2_H	0x71A2
#define MIINEPORTE3		0x71A3
#define MIINEPORTE3_H	0x71A4


/* error code */
#define DSC_OK			1
#define DSC_FAIL		-1
#define DSC_TOUT		-2
#define DSC_SOCKET		-3
#define DSC_USER_BREAK		-4
#define	DSC_PARAM		-5
#define DSC_FOPEN_FAIL		-6
#define	DSC_FLASH_LEN		-7
#define	DSC_FIRM_FORMAT		-9
#define DSC_MAX_LIMIT		-10
#define DSC_MEM_ALLOC		-11
#define DSC_NOT_LOGIN		-12

#define DS_HANDLE		int
#define IPLHANDLE		SOCKET

/* dsc_GetSerialIOCtl */
#define B50		0x00
#define B75		0x01
#define B110		0x02
#define B134		0x03
#define B150		0x04
#define B300		0x05
#define B600		0x06
#define B1200		0x07
#define B1800		0x08
#define B2400		0x09
#define B4800		0x0A
#define B7200		0x0B
#define B9600		0x0C
#define B19200		0x0D
#define B38400		0x0E
#define B57600		0x0F
#define B115200 	0x10
#define B230400 	0x11
#define B460800 	0x12
#define B921600 	0x13

#define BIT_5	0x00
#define BIT_6	0x01
#define BIT_7	0x02
#define BIT_8	0x03

#define STOP_1	0x00
#define STOP_2	0x04

#define P_NONE		0x00
#define P_ODD		0x08
#define P_EVEN		0x18
#define P_MRK		0x28
#define P_SPC		0x38

#define NONE_FLOWCTRL	0
#define HW_FLOWCTRL	1
#define SW_FLOWCTRL	2
#define DTRDSR_FLOWCTRL	3

/*      dsc_GetSerialLineStatus */
#define L_RTS	0x02
#define L_DTR	0x01
#define L_CTS	0x10
#define L_DSR	0x20
#define L_DCD	0x80

/* set console */
#define CON_WEB			0x0001
#define CON_TELNET		0x0002
#define CON_UTIL		0x0040
#define CON_AUTOCFG		0x0100

/* opmode */
#define	DRV_MODE		0x02
#define RFC2217_MODE	0x14
#define TCPSVR_MODE		0x0A
#define TCPCLI_MODE		0x0D
#define UDP_MODE		0x0E
#define EMODEM_MODE		0x0C
#define DISABLE_MODE	0x0F
#define MCSC_MODE		0x40

#define MACLEN		6       /* MAC Address field byte count */
#define HOSTNAMELEN	40      /* Host Domain Name max length */
#define SVRNAMELEN      40      /* Device Server Name */
#define PORTNAMELEN	16
#define MAXPORT         16
	
typedef struct _DS_INFO{
	DWORD	apid;
	WORD	hwid;
	WORD	flag;
	DWORD	real_ip_addr;
	DWORD	pseudo_ip_addr;
	DWORD	host_ip_addr;
	BYTE	mac[MACLEN];
}DS_INFO, *PDS_INFO;

typedef struct _KERNELINFO{
	DWORD		firm_version;
	DWORD		bios_version;
	DWORD		serial_no;
	WORD		flag;
	WORD		reserved;
}KERNELINFO, *PKERNELINFO;

typedef struct _IPLOCATIONINFO{
	char		loc_server[HOSTNAMELEN];
	WORD		loc_port;
	WORD		loc_period;
}IPLOCATIONINFO, *PIPLOCATIONINFO;

typedef struct _IFCONFIGINFO{
	WORD		ifid;
	WORD		flag;
	DWORD		ipaddr;
	DWORD		netmask;
	DWORD		gateway;
}IFCONFIGINFO, *PIFCONFIGINFO;

typedef struct	_SERPARMITEM{
	DWORD		baud;
	BYTE		mode;
	BYTE		flowctrl;
	BYTE		reserve[2];
}SERPARMITEM, *PSERPARMITEM;

typedef struct _SERDATACNT{
	DWORD		txcnt;
	DWORD		rxcnt;
	DWORD		total_txcnt;
	DWORD		total_rxcnt;
}SERDATACNT, *PSERDATACNT;

typedef struct _IPLOCATION_DATA{
	BYTE		name[SVRNAMELEN];
	DWORD		apid;
	WORD		hwid;
	BYTE		mac[MACLEN];
	DWORD		serialno;
	DWORD		ip;
	WORD		port;
	WORD		reserve;
}IPLOCATION_DATA, *PIPLOCATION_DATA;

typedef struct _SNMPINFO{
	BYTE		is_enabled;
    BYTE		reserved[3];
	char		community[HOSTNAMELEN];
	char		contact[HOSTNAMELEN];
	char		location[HOSTNAMELEN];
	char		trap_host[HOSTNAMELEN];
}SNMPINFO, *PSNMPINFO;

typedef struct _ACCESSIPINFO{
    DWORD		mode;
	DWORD		ip_addr;
    DWORD		mask;
}ACCESSIPINFO, *PACCESSIPINFO;

typedef struct _SCMD_INFO{
        int     serial_command;
        int     scmd_special;
}SCMD_INFO;

typedef struct	_PHY_MODE{
        BYTE	current;
        BYTE	last;
        BYTE	status;
        BYTE	reserved;        
}PHY_MODE;

typedef struct _PHY_INFO{
        BYTE		index;
        BYTE        interfaces;
        WORD		reserved;
        PHY_MODE	phy_mode[2];	
}PHY_INFO;

typedef struct _GRAARP_INFO{
        BYTE		lan;
        BYTE        enable;
        WORD		period;
}GRAARP_INFO;

typedef struct _GRAARP_INFO_SET{
        BYTE		lan;
        BYTE        enable;
        WORD		period;
}GRAARP_INFO_SET;

typedef struct _CONSOLEEX{
	WORD	console;
	BYTE	reserved[2];
}CONSOLEEX, *PCONSOLEEX;

typedef struct _CONSOLEPORT{
	WORD	http_port;
	WORD	telnet_port;
}CONSOLEPORT, *PCONSOLEPORT;

typedef struct _ASYNCIOCTL{
	DWORD	baudrate;
	BYTE	mode;
	BYTE	flowctrl;
	BYTE	reserved[2];
}ASYNCIOCTL, *PASYNCIOCTL;

typedef int (CALLBACK* WNDENUMSEARCHPROC)(PDS_INFO);
typedef int (CALLBACK* WNDLIBPROC)(DWORD, int, int, LPVOID);

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_BUILD_DLL) || defined(NE_EXPORTS)
#define IMPORT_EXPORT __declspec(dllexport)
#else
#define IMPORT_EXPORT __declspec(dllimport)
#endif

#define SDKCI_FUNC	__stdcall

/* Search & Attach */
IMPORT_EXPORT int SDKCI_FUNC dsc_EnumSearch(DWORD server_ip, WNDENUMSEARCHPROC lpenumproc);
IMPORT_EXPORT int SDKCI_FUNC dsc_Attach(PDS_INFO info, DS_HANDLE *dshandle);
IMPORT_EXPORT int SDKCI_FUNC dsc_Detach(DS_HANDLE dshandle);
IMPORT_EXPORT int SDKCI_FUNC dsc_Login(DS_HANDLE dshandle, char *password);
IMPORT_EXPORT int SDKCI_FUNC dsc_Logout(DS_HANDLE dshandle);

/* System Control */
IMPORT_EXPORT int SDKCI_FUNC dsc_GetKernelInfo(DS_HANDLE dshandle, PKERNELINFO info);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetDSINFO(DS_HANDLE dshandle, PDS_INFO dsinfo);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetPassword(DS_HANDLE dshandle, char *password);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetIPFilter(DS_HANDLE dshandle, int idx, int *enable_filter, PACCESSIPINFO info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetIPFilter(DS_HANDLE dshandle, int enable_ipfilter, PACCESSIPINFO info);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetConsole(DS_HANDLE dshandle, int *settings);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetConsole(DS_HANDLE dshandle, int settings);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetName(DS_HANDLE dshandle, char *name);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetName(DS_HANDLE dshandle, char *name);
IMPORT_EXPORT int SDKCI_FUNC dsc_Locate(DS_HANDLE dshandle, int sw);
IMPORT_EXPORT int SDKCI_FUNC dsc_SaveAndRestart(DS_HANDLE dshandle);
IMPORT_EXPORT int SDKCI_FUNC dsc_Restart(DS_HANDLE dshandle);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetCmdState(DS_HANDLE dshandle, SCMD_INFO * scmd_info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetCmdState(DS_HANDLE dshandle, SCMD_INFO * scmd_info);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetPHYStatus(DS_HANDLE dshandle, BYTE index, PHY_INFO * phy_info);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetGraArp(DS_HANDLE dshandle, BYTE index, GRAARP_INFO * gra_info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetGraArp(DS_HANDLE dshandle, GRAARP_INFO_SET * gra_arp_setting);
int SDKCI_FUNC dsc_GetConsoleEx(DS_HANDLE dshandle, PCONSOLEEX conf);
int SDKCI_FUNC dsc_SetConsoleEx(DS_HANDLE dshandle, PCONSOLEEX conf);
int SDKCI_FUNC dsc_GetConsolePort(DS_HANDLE dshandle, PCONSOLEPORT conf);
int SDKCI_FUNC dsc_SetConsolePort(DS_HANDLE dshandle, PCONSOLEPORT conf);

/* Network Config */
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSNMP(DS_HANDLE dshandle, PSNMPINFO snmpinfo);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetSNMP(DS_HANDLE dshandle, PSNMPINFO snmpinfo);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetDNS(DS_HANDLE dshandle, int ifid, DWORD *dns1, DWORD *dns2);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetDNS(DS_HANDLE dshandle, int ifid, DWORD dns1, DWORD dns2);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetIP(DS_HANDLE dshandle, int ifid, DWORD *ip);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetIP(DS_HANDLE dshandle, int ifid, DWORD newip);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetNetmask(DS_HANDLE dshandle, int ifid, DWORD *netmask);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetNetmask(DS_HANDLE dshandle, int ifid, DWORD netmask);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetGateway(DS_HANDLE dshandle, int ifid, DWORD *gateway);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetGateway(DS_HANDLE dshandle, int ifid, DWORD gateway);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetIPConfig(DS_HANDLE dshandle, int ifid, int *setting);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetIPConfig(DS_HANDLE dshandle, int ifid, int setting);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetIfConfig(DS_HANDLE dshandle, int maxif, int *retcnt, PIFCONFIGINFO info);

/* Serial Port Config */
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialPortName(DS_HANDLE dshandle, int port, char name[MAXPORT][PORTNAMELEN]);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetSerialPortName(DS_HANDLE dshandle, int port, char *portname);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialIOCtl(DS_HANDLE dshandle, int port, int mode, PSERPARMITEM info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetSerialIOCtl(DS_HANDLE dshandle, int port, BYTE baud, BYTE mode, BYTE flowctrl);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialFIFO(DS_HANDLE dshandle, int port, int mode,  LPBYTE info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetSerialFIFO(DS_HANDLE dshandle, int port, int setting);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialInterface(DS_HANDLE dshandle, int port, int mode, LPBYTE info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetSerialInterface(DS_HANDLE dshandle, int port, int setting);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialLineStatus(DS_HANDLE dshandle, int port, LPBYTE info);
IMPORT_EXPORT int SDKCI_FUNC dsc_GetSerialDataCount(DS_HANDLE dshandle, int port, PSERDATACNT info);
int SDKCI_FUNC dsc_SetAsyncIoctl(DS_HANDLE dshandle, int port, PASYNCIOCTL param);

/* Auto IP Report */
IMPORT_EXPORT int SDKCI_FUNC dsc_GetIPLocation(DS_HANDLE dshandle, int ifid, PIPLOCATIONINFO info);
IMPORT_EXPORT int SDKCI_FUNC dsc_SetIPLocation(DS_HANDLE dshandle, int ifid, PIPLOCATIONINFO info);

/* Library Config */
IMPORT_EXPORT int SDKCI_FUNC dsc_LibSetTimeout(DS_HANDLE dshandle, int timeout, int retrycnt);
IMPORT_EXPORT int SDKCI_FUNC dsc_LibSetUpgTimeout(DS_HANDLE dshandle, DWORD timeout);
IMPORT_EXPORT void SDKCI_FUNC dsc_SetSearchOpt(int timeout, int retrycnt);

/* OP mode */
int SDKCI_FUNC dsc_GetOpModeEx(DS_HANDLE dshandle, int port, int channel, int *mode);
int SDKCI_FUNC dsc_SetOpModeEx(DS_HANDLE dshandle, int port, int channel, int mode);

#ifdef __cplusplus
}
#endif

#endif
